/***************************************************************************
 *   Copyright (C) 2005 by Michal Vaner (Vorner)                           *
 *   vorner@seznam.cz                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "misc.h"//inclue my header
#include <string>

std::string filter_line(const char *line) {
  if ((!line) || (!*line)) return "";//it is empty
  char *ln = strdup(line);//copy it to allow it changeable
  std::string result = "";//make an empty line there, it will be put there
  char *start = NULL;
  for (char *c = ln; *c; c++) {//run trough the line
    if ((*c == '\n') || (*c == '\r')) {
      if (start) {//there is something to add
        *c = '\0';//make an end here just for now
        result += start;//put it into the result
        start = NULL;//and there is no start now
      }
    } else {
      if (!start) start = c;//so, it is the first here, start it then
    }
  }
  if (start) {//it is 'till the end, put it there as well
    result += start;//the rest
  }
  free(ln);//free, what you allocated
  return result;//and give it to him
}
